<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class ParametrizacoesNoCash {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    // parametrizações no cash
    public function find($nrorg){
        $return = array();
        
        $params = array(
            'NRORG' =>  $nrorg
        );
        $query = $this->entityManager->getConnection()->fetchAssoc(Utilities\Query::CONSULTA_NOCASH, $params);
        return $query;
    }
    
    public function saveNew(object $row){
        $params = [
            'URLLOGO'           =>  $row['URLLOGO'],
            'CORESJSON'         =>  $row['CORESJSON'],
            'URLAPIPAG'         =>  $row['URLAPIPAG'],
            'MERCHANTID'        =>  $row['MERCHANTID'],
            'MERCHANTKEY'       =>  $row['MERCHANTKEY'],
            'PAYMENTCOMPANY'    =>  $row['PAYMENTCOMPANY'],
            'HABCADASTRO'       =>  $row['HABCADASTRO'],
            'NUMEROAJUDA'       =>  $row['NUMEROAJUDA'],
            'MAILFALE'          =>  $row['MAILFALE'],
            'RECSENHAMSG'       =>  $row['RECSENHAMSG'],
            'IDIOMAPRINC'       =>  $row['IDIOMAPRINC'],
            'IDIOMAADIC'        =>  $row['IDIOMAADIC'],
            'NRORG'             =>  $row['NRORG'],
            'IDATIVO'           =>  'S',
            'DTULTATU'          =>  NULL,
            'NRORGINCLUSAO'     =>  $row['NRORG'],
            'CDOPERINCLUSAO'    =>  '1',
            'NRORGULTATU'       =>  NULL,
            'CDOPERULTATU'      =>  NULL,
            'URLAPIFINANCEIRO'  =>  $row['URLAPIFINANCEIRO'],
            'URLTERMORESP'      =>  $row['URLTERMORESP']
        ];
        
        $this->entityManager->getConnection()->executeQuery(Utilities\Query::SAVE_PARAM_NOCASH, $params);
    }
    
    public function update(object $row){
        $params = [
            'URLLOGO'           =>  $row['URLLOGO'],
            'CORESJSON'         =>  $row['CORESJSON'],
            'URLAPIPAG'         =>  $row['URLAPIPAG'],
            'MERCHANTID'        =>  $row['MERCHANTID'],
            'MERCHANTKEY'       =>  $row['MERCHANTKEY'],
            'PAYMENTCOMPANY'    =>  $row['PAYMENTCOMPANY'],
            'HABCADASTRO'       =>  $row['HABCADASTRO'],
            'NUMEROAJUDA'       =>  $row['NUMEROAJUDA'],
            'MAILFALE'          =>  $row['MAILFALE'],
            'RECSENHAMSG'       =>  $row['RECSENHAMSG'],
            'IDIOMAPRINC'       =>  $row['IDIOMAPRINC'],
            'IDIOMAADIC'        =>  $row['IDIOMAADIC'],
            'NRORG'             =>  $row['NRORG'],
            'CDOPERINCLUSAO'    =>  '1',
            'NRORGULTATU'       =>  $row['NRORG'],
            'CDOPERULTATU'      =>  '1',
            'URLAPIFINANCEIRO'  =>  $row['URLAPIFINANCEIRO'],
            'URLTERMORESP'      =>  $row['URLTERMORESP']
        ];

        $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_NOCASHPARAMS, $params);
    }
    
    public function selectFileServerUrl($nrorg){
        $param = [
            'NRORG' =>  $nrorg];
        
        return $this->entityManager->getConnection()->fetchAssoc(Utilities\Query::SELECT_FILESERVERURL, $param);
    }
    
    public function checkNoCashUser($row){
        $query = $this->entityManager->getConnection()->fetchAll(Utilities\Query::CHECK_NOCASH_USER, $row);
        
        return $query;
    }
    
    public function saveLogin($params){
        $query = $this->entityManager->getConnection()->executeQuery(Utilities\Query::SAVELOGIN_NOCASH, $params);
        
        return $query;
    }
    
    // parametrizações no cash por filial
    public function findParamsFilial(){
        $query = $this->entityManager->getConnection()->fetchAll(Utilities\Query::FIND_NOCASH_FILIAL);
        
        return $query;
    }
    
    public function deleteParamsFilial($row){
        $params = [
            'CDFILIAL'  =>  $row['CDFILIAL'],
            'CDCLIENTE' =>  $row['CDCLIENTE']
        ];
        
        $query = $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_PARAMS_FILIA, $params);
        
        return $query;
    }
    
    public function updateParamsFilial($row){
        $params = [
            'PAGHABJSON'        =>  $row['PAGHABJSON'],
            'NRORGULTATU'       =>  $row['NRORG'],
            'CDOPERULTATU'      =>  1,
            'CDCLIENTE_OLD'     =>  $row['backupRow']['CDCLIENTE'],
            'CDFILIAL_OLD'      =>  $row['backupRow']['CDFILIAL'],
            'PAGHABJSON_OLD'    =>  $row['backupRow']['PAGHABJSON']
            
        ];
        
        $query = $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_PARAMS_FILIAL, $params);
        
        return $query;
    }
    
    public function insertParamsFilial($row){
        $params = [
            'CDCLIENTE'         =>  $row['CDCLIENTE'],
            'CDFILIAL'          =>  $row['CDFILIAL'],
            'PAGHABJSON'        =>  $row['PAGHABJSON'],
            'NRORG'             =>  $row['NRORG'],
            'IDATIVO'           =>  'S',
            'NRORGINCLUSAO'     =>  $row['NRORG'],
            'CDOPERINCLUSAO'    =>  1,
            'NRORGULTATU'       =>  NULL,
            'CDOPERULTATU'      =>  NULL
        ];
        
        $query = $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_PARAMS_FILIAL, $params);
    }
}